//
//  It is file 'crc32.hpp'
//
//  Copyright (C) 1992, 1993 Serge Pachkovsky, ps@che.nsk.su
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//

typedef unsigned long	CRC32 ;
typedef unsigned char	BYTE ;

const	CRC32	CRC32_POLY  = 0xEDB88320ul ;
const	CRC32	CRC32_MASK  = 0xFFFFFFFFul ;

class CRC_32 {
    static CRC32    crc_table[ 256 ] ;
    CRC32	    current_crc ;
    public:
    static void     FillCRCTable( CRC32 poly ) ;

		    CRC_32() ;
    void	    AddByte( BYTE ) ;
		    operator CRC32() ;
    } ;

inline
CRC_32::CRC_32()
{
current_crc = CRC32_MASK ;
}

inline void
CRC_32::AddByte( BYTE c )
{
current_crc = crc_table[ BYTE(current_crc) ^ BYTE(c) ] ^ (current_crc >> 8) ;
}

inline
CRC_32::operator CRC32()
{
return current_crc ^ CRC32_MASK ;
}
