//
//  It is file 'machine.hpp'
//
//  Copyright (C) 1992, 1993 Serge Pachkovsky, ps@che.nsk.su
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
const unsigned long DefaultMemorySize	    = 100 * 1024L ;
const int	    IOBufSize		    =	2 * 1024 ;
const int	    ProgressReportStep	    =	     512 ;
const int	    MaxNameLength	    =	     255 ;
const unsigned long TriggerStoringThreshold = 5 ;

enum CompletionCode {
    Completed	 = 0,
    GenericError = -1,
    OutOfMemory  = -100, OutOfDisk, Break,
    FileNotFound, ReadError, WriteError,
    CantGetTimeStamps, CantSetTimeStamps,
    BadCRC,
    } ;

enum DecompressActions {
    Decompress, GetInfo, TestFragment
    } ;

const unsigned short	FileIsStored   = 0xFFFF ;

struct FileInfo {
    unsigned long   CompSize ;
    unsigned long   UncompSize ;
    unsigned long   CRC32 ;
    unsigned long   MemoryUsed ;
    unsigned short  ModelOrder ;    // 0xFFFF means what file is stored
    unsigned short  CharsCount ;
    TimeStamp	    Modified ;
    char	   *name ;

		    FileInfo(){ name = NULL ; }
		   ~FileInfo(){ delete name ; }
    static void     Title( ostream & ) ;
    friend ostream &operator<<( ostream &, FileInfo & ) ;
    } ;

CompletionCode	CompressFile( int out, char * const name, int order, unsigned long memory ) ;
CompletionCode	DecompressFile( int in, FileInfo *, DecompressActions = Decompress ) ;
const char *	MachineStrerror( CompletionCode errno ) ;
