//
//  It is file 'timestamp.cc'
//
//  Copyright (C) 1992, 1993 Serge Pachkovsky, ps@che.nsk.su
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 1, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
#include "stdinc.hpp"
#include "timestamp.hpp"

ostream &
operator << ( ostream & str, TimeStamp stamp )
{
    char    old_fill = str.fill( '0' ) ;

str << setw( 2 ) << stamp.GetMonths()	   << "/"
    << setw( 2 ) << stamp.GetDays()	   << "/"
    << setw( 2 ) << stamp.GetYears() % 100 << " "
    << setw( 2 ) << stamp.GetHours()	   << ":"
    << setw( 2 ) << stamp.GetMinutes()	   << ":"
    << setw( 2 ) << stamp.GetSeconds() ;

str.fill( old_fill ) ;
return str ;
}

int
GetTimeStamp( const char *name, TimeStamp & modified )
{
    struct  stat    stats ;

if( stat( name, & stats ) != 0 )
    return -1 ;
modified = TimeStamp( localtime( &stats.st_mtime ) ) ;
return 0 ;
}

int
SetTimeStamp( const char *name, TimeStamp modified )
{
//cerr << "SetTimeStamp( " << name << ", " << modified << ")\n" ;

    struct tm	    tmbuf ;
    struct utimbuf  times ;

modified.AllAtOnce( &tmbuf ) ;
//cerr << "tm( " << tmbuf.tm_sec  << ", " << tmbuf.tm_min  << ", " << tmbuf.tm_hour  << ", "
//		 << tmbuf.tm_mday << ", " << tmbuf.tm_mon  << ", " << tmbuf.tm_year  << ", "
//		 << tmbuf.tm_wday << ", " << tmbuf.tm_yday << ", " << tmbuf.tm_isdst << ")\n" ;
times.actime  =
times.modtime = mktime( &tmbuf ) ;
#ifdef __TURBOC__
return utime( (char *)name, &times ) ;	 // Why this BC 3.1 libraries don't use const properly?!
#else
return utime( name, &times ) ;
#endif
}
